integrations.sh
← all integrations

Email Activity (beta)

OpenAPI apis-guru emailmarketing

The Beta endpoints for the new Email Activity APIs - functionality is subject to change without notice. You may not have access to this Beta endpoint.

Email Activity offers filtering and search by event type for two days worth of data. There is an optional add-on to store 60 days worth of data. This add-on also gives you access to the ability to download a CSV of the 60 days worth of email event data. The Beta endpoints for the new Email Activity APIs - functionality is subject to change without notice. You may not have access to this Beta endpoint.

Email Activity offers filtering and search by event type for two days worth of data. There is an optional add-on to store 60 days worth of data. This add-on also gives you access to the ability to download a CSV of the 60 days worth of email event data.

Homepage
https://api.apis.guru/v2/specs/sendgrid.com/1.0.0.json
Provider
sendgrid.com
OpenAPI version
3.0.0
Spec (JSON)
https://api.apis.guru/v2/specs/sendgrid.com/1.0.0/openapi.json
Spec (YAML)
https://api.apis.guru/v2/specs/sendgrid.com/1.0.0/openapi.yaml

Tools (336)

Extracted live via the executor SDK.

  • alerts.deleteAlertsAlertId

    This endpoint allows you to delete an alert.

    Alerts allow you to specify an email address to receive notifications regarding your email usage or statistics.

    • Usage alerts allow you to set the threshold at which an alert will be sent.
    • Stats notifications allow you to set how frequently you would like to receive email statistics reports. For example, "daily", "weekly", or "monthly".

    For more information about alerts, please see our .

  • alerts.getAlerts

    This endpoint allows you to retrieve all of your alerts.

    Alerts allow you to specify an email address to receive notifications regarding your email usage or statistics.

    • Usage alerts allow you to set the threshold at which an alert will be sent.
    • Stats notifications allow you to set how frequently you would like to receive email statistics reports. For example, "daily", "weekly", or "monthly".

    For more information about alerts, please see our .

  • alerts.getAlertsAlertId

    This endpoint allows you to retrieve a specific alert.

    Alerts allow you to specify an email address to receive notifications regarding your email usage or statistics.

    • Usage alerts allow you to set the threshold at which an alert will be sent.
    • Stats notifications allow you to set how frequently you would like to receive email statistics reports. For example, "daily", "weekly", or "monthly".

    For more information about alerts, please see our .

  • alerts.patchAlertsAlertId

    This endpoint allows you to update an alert.

    Alerts allow you to specify an email address to receive notifications regarding your email usage or statistics.

    • Usage alerts allow you to set the threshold at which an alert will be sent.
    • Stats notifications allow you to set how frequently you would like to receive email statistics reports. For example, "daily", "weekly", or "monthly".

    For more information about alerts, please see our .

  • alerts.postAlerts

    This endpoint allows you to create a new alert.

    Alerts allow you to specify an email address to receive notifications regarding your email usage or statistics. There are two types of alerts that can be created with this endpoint:

    • usage_limit allows you to set the threshold at which an alert will be sent.
    • stats_notification allows you to set how frequently you would like to receive email statistics reports. For example, "daily", "weekly", or "monthly".

    For more information about alerts, please see our .

  • apiKeyPermissions.getScopes

    This endpoint returns a list of all scopes that this user has access to.

    API Keys are used to authenticate with .

    API Keys may be assigned certain permissions, or scopes, that limit which API endpoints they are able to access.

    This endpoint returns all the scopes assigned to the key you use to authenticate with it. To retrieve the scopes assigned to another key, you can pass an API key ID to the "Retrieve an existing API key" endpoint.

    For a more detailed explanation of how you can use API Key permissions, please visit our .

  • apiKeys.createApiKeys

    This endpoint allows you to create a new API Key for the user.

    To create your initial SendGrid API Key, you should . Once you have created a first key with scopes to manage additional API keys, you can use this API for all other key management.

    There is a limit of 100 API Keys on your account.

    A JSON request body containing a name property is required when making requests to this endpoint. If the number of maximum keys, 100, is reached, a 403 status will be returned.

    Though the name field is required, it does not need to be unique. A unique API key ID will be generated for each key you create and returned in the response body.

    It is not necessary to pass a scopes field to the API when creating a key, but you should be aware that omitting the scopes field from your request will create a key with "Full Access" permissions by default.

    See the for all available scopes. An API key's scopes can be updated after creation using the "Update API keys" endpoint.

  • apiKeys.deleteApiKeysApiKeyId

    This endpoint allows you to revoke an existing API Key using an api_key_id

    Authentications using a revoked API Key will fail after after some small propogation delay. If the API Key ID does not exist, a 404 status will be returned.

  • apiKeys.getApiKeys

    This endpoint allows you to retrieve all API Keys that belong to the authenticated user.

    A successful response from this API will include all available API keys' names and IDs.

    For security reasons, there is not a way to retrieve the key itself after it's created. If you lose your API key, you must create a new one. Only the "Create API keys" endpoint will return a key to you and only at the time of creation.

    An api_key_id can be used to update or delete the key, as well as retrieve the key's details, such as its scopes.

  • apiKeys.getApiKeysApiKeyId

    This endpoint allows you to retrieve a single API key using an api_key_id.

    The endpoint will return a key's name, ID, and scopes. If the API Key ID does not, exist a 404 status will be returned.

    See the for all available scopes. An API key's scopes can be updated after creation using the "Update API keys" endpoint.

  • apiKeys.patchApiKeysApiKeyId

    This endpoint allows you to update the name of an existing API Key.

    You must pass this endpoint a JSON request body with a name property, which will be used to rename the key associated with the api_key_id passed in the URL.

  • apiKeys.putApiKeysApiKeyId

    This endpoint allows you to update the name and scopes of a given API key.

    You must pass this endpoint a JSON request body with a name field and a scopes array containing at least one scope. The name and scopes fields will be used to update the key associated with the api_key_id in the request URL.

    If you need to update a key's scopes only, pass the name field with the key's existing name; the name will not be modified. If you need to update a key's name only, use the "Update API key name" endpoint.

    See the for all available scopes.

  • blocksApi.deleteSuppressionBlocks

    This endpoint allows you to delete all email addresses on your blocks list.

    There are two options for deleting blocked emails:

    1. You can delete all blocked emails by setting delete_all to true in the request body.
    2. You can delete a selection of blocked emails by specifying the email addresses in the emails array of the request body.
  • blocksApi.deleteSuppressionBlocksEmail

    This endpoint allows you to delete a specific email address from your blocks list.

  • blocksApi.getSuppressionBlocks

    This endpoint allows you to retrieve all email addresses that are currently on your blocks list.

  • blocksApi.getSuppressionBlocksEmail

    This endpoint allows you to retrieve a specific email address from your blocks list.

  • bouncesApi.deleteSuppressionBounces

    This endpoint allows you to delete all emails on your bounces list.

    There are two options for deleting bounced emails:

    1. You can delete all bounced emails by setting delete_all to true in the request body.
    2. You can delete a selection of bounced emails by specifying the email addresses in the emails array of the request body.
  • bouncesApi.deleteSuppressionBouncesEmail

    This endpoint allows you to remove an email address from your bounce list.

  • bouncesApi.getSuppressionBounces

    This endpoint allows you to retrieve all of your bounces.

  • bouncesApi.getSuppressionBouncesEmail

    This endpoint allows you to retrieve a specific bounce by email address.

  • campaignsApi.deleteCampaignsCampaignId

    This endpoint allows you to delete a specific campaign.

  • campaignsApi.deleteCampaignsCampaignIdSchedules

    This endpoint allows you to unschedule a campaign that has already been scheduled to be sent.

    A successful unschedule will return a 204. If the specified campaign is in the process of being sent, the only option is to cancel (a different method).

  • campaignsApi.getCampaigns

    This endpoint allows you to retrieve a list of all of your campaigns.

    Returns campaigns in reverse order they were created (newest first).

    Returns an empty array if no campaigns exist.

  • campaignsApi.getCampaignsCampaignId

    This endpoint allows you to retrieve a specific campaign.

  • campaignsApi.getCampaignsCampaignIdSchedules

    This endpoint allows you to retrieve the date and time that a campaign has been scheduled to be sent.

  • campaignsApi.patchCampaignsCampaignId

    This endpoint allows you to update a specific campaign.

    This is especially useful if you only set up the campaign using POST /campaigns, but didn't set many of the parameters.

  • campaignsApi.patchCampaignsCampaignIdSchedules

    This endpoint allows to you change the scheduled time and date for a campaign to be sent.

  • campaignsApi.postCampaigns

    This endpoint allows you to create a campaign.

    In order to send or schedule the campaign, you will be required to provide a subject, sender ID, content (we suggest both html and plain text), and at least one list or segment ID. This information is not required when you create a campaign.

  • campaignsApi.postCampaignsCampaignIdSchedules

    This endpoint allows you to schedule a specific date and time for your campaign to be sent.

    If you have the flexibility, it's better to schedule mail for off-peak times. Most emails are scheduled and sent at the top of the hour or half hour. Scheduling email to avoid those times (for example, scheduling at 10:53) can result in lower deferral rates because it won't be going through our servers at the same times as everyone else's mail.

  • campaignsApi.postCampaignsCampaignIdSchedulesNow

    This endpoint allows you to immediately send an existing campaign.

    Normally a POST request would have a body, but since this endpoint is telling us to send a resource that is already created, a request body is not needed.

  • campaignsApi.postCampaignsCampaignIdSchedulesTest

    This endpoint allows you to send a test campaign.

    To send to multiple addresses, use an array for the JSON "to" value ["one@address","two@address"]

  • cancelScheduledSends.deleteUserScheduledSendsBatchId

    This endpoint allows you to delete the cancellation/pause of a scheduled send.

    Scheduled sends cancelled less than 10 minutes before the scheduled time are not guaranteed to be cancelled.

  • cancelScheduledSends.getMailBatchBatchId

    This endpoint allows you to validate a batch ID.

    When you pass a valid batch_id to this endpoint, it will return a 200 status code and the batch ID itself.

    If you pass an invalid batch_id to the endpoint, you will receive a 400 level status code and an error message.

    A batch_id does not need to be assigned to a scheduled send to be considered valid. A successful response means only that the batch_id has been created, but it does not indicate that it has been associated with a send.

  • cancelScheduledSends.getUserScheduledSends

    This endpoint allows you to retrieve all cancelled and paused scheduled send information.

    This endpoint will return only the scheduled sends that are associated with a batch_id. If you have scheduled a send using the /mail/send endpoint and the send_at field but no batch_id, the send will be scheduled for delivery; however, it will not be returned by this endpoint. For this reason, you should assign a batch_id to any scheduled send you may need to pause or cancel in the future.

  • cancelScheduledSends.getUserScheduledSendsBatchId

    This endpoint allows you to retrieve the cancel/paused scheduled send information for a specific batch_id.

  • cancelScheduledSends.patchUserScheduledSendsBatchId

    This endpoint allows you to update the status of a scheduled send for the given batch_id.

    If you have already set a cancel or pause status on a scheduled send using the "Cancel or pause a scheduled send" endpoint, you can update it's status using this endpoint. Attempting to update a status once it has been set with the "Cancel or pause a scheduled send" endpoint will result in a 400 error.

  • cancelScheduledSends.postMailBatch

    This endpoint allows you to generate a new batch ID.

    Once a batch_id is created, you can associate it with a scheduled send using the /mail/send endpoint. Passing the batch_id as a field in the /mail/send request body will assign the ID to the send you are creating.

    Once an ID is associated with a scheduled send, the send can be accessed and its send status can be modified using the batch_id.

  • cancelScheduledSends.postUserScheduledSends

    This endpoint allows you to cancel or pause a scheduled send associated with a batch_id.

    Passing this endpoint a batch_id and status will cancel or pause the scheduled send.

    Once a scheduled send is set to pause or cancel you must use the "Update a scheduled send" endpoint to change its status or the "Delete a cancellation or pause from a scheduled send" endpoint to remove the status. Passing a status change to a scheduled send that has already been paused or cancelled will result in a 400 level status code.

    If the maximum number of cancellations/pauses are added to a send, a 400 level status code will be returned.

  • categories.getCategories

    This endpoint allows you to retrieve a list of all of your categories.

  • categories.getCategoriesStats

    This endpoint allows you to retrieve all of your email statistics for each of your categories.

    If you do not define any query parameters, this endpoint will return a sum for each category in groups of 10.

  • categories.getCategoriesStatsSums

    This endpoint allows you to retrieve the total sum of each email statistic for every category over the given date range.

    If you do not define any query parameters, this endpoint will return a sum for each category in groups of 10.

  • certificates.deleteSsoCertificatesCertId

    This endpoint allows you to delete an SSO certificate.

    You can retrieve a certificate's ID from the response provided by the "Get All SSO Integrations" endpoint.

  • certificates.getSsoCertificatesCertId

    This endpoint allows you to retrieve an individual SSO certificate.

  • certificates.getSsoIntegrationsIntegrationIdCertificates

    This endpoint allows you to retrieve all your IdP configurations by configuration ID.

    The integration_id expected by this endpoint is the id returned in the response by the "Get All SSO Integrations" endpoint.

  • certificates.patchSsoCertificatesCertId

    This endpoint allows you to update an existing certificate by ID.

    You can retrieve a certificate's ID from the response provided by the "Get All SSO Integrations" endpoint.

  • certificates.postSsoCertificates

    This endpoint allows you to create an SSO certificate.

  • contacts.deleteMcContacts

    This endpoint can be used to delete one or more contacts.

    The query parameter ids must set to a comma-separated list of contact IDs for bulk contact deletion.

    The query parameter delete_all_contacts must be set to "true" to delete all contacts.

    You must set either ids or delete_all_contacts.

    Deletion jobs are processed asynchronously.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.getMarketingContactsExports

    Use this endpoint to retrieve details of all current exported jobs.

    It will return an array of objects, each of which records an export job in flight or recently completed.

    Each object's export_type field will tell you which kind of export it is and its status field will indicate what stage of processing it has reached. Exports which are ready will be accompanied by a urls field which lists the URLs of the export's downloadable files — there will be more than one if you specified a maximum file size in your initial export request.

    Use this endpoint if you have exports in flight but do not know their IDs, which are required for the "Export Contacts Status" endpoint.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.getMarketingContactsImportsId

    This endpoint can be used to check the status of a contact import job.

    Use the job_id from the "Import Contacts," "Add or Update a Contact," or "Delete Contacts" endpoints as the id in the path parameter.

    If there is an error with your PUT request, download the errors_url file and open it to view more details.

    The job status field indicates whether the job is pending, completed, errored, or failed.

    Pending means not started. Completed means finished without any errors. Errored means finished with some errors. Failed means finshed with all errors, or the job was entirely unprocessable: for example, if you attempt to import file format we do not support.

    The results object will have fields depending on the job type.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.getMcContactsCount

    This endpoint returns the total number of contacts you have stored.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.getMcContactsExportsId

    This endpoint can be used to check the status of a contact export job.

    To use this call, you will need the id from the "Export Contacts" call.

    If you would like to download a list, take the id that is returned from the "Export Contacts" endpoint and make an API request here to get the urls. Once you have the list of URLs, make a GET request on each URL to download your CSV file(s).

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.getMcContactsId

    This endpoint returns the full details and all fields for the specified contact.

    The "Get Contacts by Emails" endpoint can be used to get the ID of a contact.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.getMcContats

    This endpoint will return up to 50 of the most recent contacts uploaded or attached to a list.

    This list will then be sorted by email address.

    The full contact count is also returned.

    Please note that pagination of the contacts has been deprecated.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.postMarketingContactsBatch

    This endpoint is used to retrieve a set of contacts identified by their IDs.

    This can be more efficient endpoint to get contacts than making a series of individual GET requests to the "Get a Contact by ID" endpoint.

    You can supply up to 100 IDs. Pass them into the ids field in your request body as an array or one or more strings.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.postMarketingContactsSearchEmails

    This endpoint allows you to retrieve up to 100 contacts matching the searched email address(es), including any alternate_emails.

    Email addresses are unique to a contact, meaning this endpoint can treat an email address as a primary key to search by. The contact object associated with the address, whether it is their email or one of their alternate_emails will be returned if matched.

    Email addresses in the search request do not need to match the case in which they're stored, but the email addresses in the result will be all lower case. Empty strings are excluded from the search and will not be returned.

    This endpoint should be used in place of the "Search Contacts" endpoint when you can provide exact email addresses and do not need to include other filters when searching.

    If you need to access a large percentage of your contacts, we recommend exporting your contacts with the "Export Contacts" endpoint and filtering the results client side.

    This endpoint returns a 200 status code when any contacts match the address(es) you supplied. When searching multiple addresses in a single request, it is possible that some addresses will match a contact while others will not. When a partially successful search like this is made, the matching contacts are returned in an object and an error message is returned for the email address(es) that are not found.

    This endpoint returns a 404 status code when no contacts are found for the provided email address(es).

    A 400 status code is returned if any searched addresses are invalid.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.postMcContactsExports

    Use this endpoint to export lists or segments of contacts.

    If you would just like to have a link to the exported list sent to your email set the notifications.email option to true in the POST payload.

    If you would like to download the list, take the id that is returned and use the "Export Contacts Status" endpoint to get the urls. Once you have the list of URLs, make a GET request to each URL provided to download your CSV file(s).

    You specify the segements and or/contact lists you wish to export by providing the relevant IDs in, respectively, the segment_ids and list_ids fields in the request body.

    The lists will be provided in either JSON or CSV files. To specify which of these you would required, set the request body file_type field to json or csv.

    You can also specify a maximum file size (in MB). If the export file is larger than this, it will be split into multiple files.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.postMcContactsSearch

    Use this endpoint to locate contacts.

    The request body's query field accepts valid for searching for a contact.

    Because contact emails are stored in lower case, using SGQL to search by email address requires the provided email address to be in lower case. The SGQL lower() function can be used for this.

    Only the first 50 contacts that meet the search criteria will be returned.

    If the query takes longer than 20 seconds, a 408 Request Timeout status will be returned.

    Formatting the created_at and updated_at values as Unix timestamps is deprecated. Instead they are returned as ISO format as string. Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.putMcContacts

    This endpoint allows the (insert or update) of up to 30,000 contacts, or 6MB of data, whichever is lower.

    Because the creation and update of contacts is an asynchronous process, the response will not contain immediate feedback on the processing of your upserted contacts. Rather, it will contain an HTTP 202 response indicating the contacts are queued for processing or an HTTP 4XX error containing validation errors. Should you wish to get the resulting contact's ID or confirm your contacts have been updated or added, you can use the "Get Contacts by Emails" endpoint.

    Please note that custom fields need to have been already created if you wish to set their values for the contacts being upserted. To do this, please use the "Create Custom Field Definition" endpoint.

    You will see a job_id in the response to your request. This can be used to check the status of your upsert job. To do so, please use the "Import Contacts Status" endpoint.

    If the contact already exists in the system, any entries submitted via this endpoint will update the existing contact. The contact to update will be determined only by the email field and any fields omitted from the request will remain as they were. A contact's ID cannot be used to update the contact.

    The email field will be changed to all lower-case. If a contact is added with an email that exists but contains capital letters, the existing contact with the all lower-case email will be updated.

    Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contacts.putMcContactsImports

    This endpoint allows a CSV upload containing up to one million contacts or 5GB of data, whichever is smaller.

    Imports take place asynchronously: the endpoint returns a URL (upload_uri) and HTTP headers (upload_headers) which can subsequently be used to PUT a file of contacts to be imported into our system.

    Uploaded CSV files may also be .

    In either case, you must include the field file_type with the value csv in your request body.

    The field_mappings paramter is a respective list of field definition IDs to map the uploaded CSV columns to. It allows you to use CSVs where one or more columns are skipped (null) or remapped to the contact field.

    For example, if field_mappings is set to [null, "w1", "_rf1"], this means skip column 0, map column 1 to the custom field with the ID w1, and map column 2 to the reserved field with the ID _rf1. See the "Get All Field Definitions" endpoint to fetch your custom and reserved field IDs to use with field_mappings.

    Once you recieve the response body you can then initiate a second API call where you use the supplied URL and HTTP header to upload your file. For example:

    curl --upload-file "file/path.csv" "URL_GIVEN" -H 'HEADER_GIVEN'

    If you'd like to monitor the status of your import job, use the job_id and the "Import Contacts Status" endpoint. Twilio SendGrid recommends exporting your contacts regularly as a backup to avoid issues or lost data.

  • contactsApiCustomFields.deleteContactdbCustomFieldsCustomFieldId

    This endpoint allows you to delete a custom field by ID.

  • contactsApiCustomFields.getContactdbCustomFields

    This endpoint allows you to retrieve all custom fields.

  • contactsApiCustomFields.getContactdbCustomFieldsCustomFieldId

    This endpoint allows you to retrieve a custom field by ID.

  • contactsApiCustomFields.getContactdbReservedFields

    This endpoint allows you to list all fields that are reserved and can't be used for custom field names.

  • contactsApiCustomFields.postContactdbCustomFields

    This endpoint allows you to create a custom field.

    You can create up to 120 custom fields.

  • contactsApiLists.deleteContactdbLists

    This endpoint allows you to delete multiple recipient lists.

  • contactsApiLists.deleteContactdbListsListId

    This endpoint allows you to delete a specific recipient list with the given ID.

  • contactsApiLists.deleteContactdbListsListIdRecipientsRecipientId

    This endpoint allows you to delete a single recipient from a list.

  • contactsApiLists.getContactdbLists

    This endpoint allows you to retrieve all of your recipient lists. If you don't have any lists, an empty array will be returned.

  • contactsApiLists.getContactdbListsListId

    This endpoint allows you to retrieve a single recipient list.

  • contactsApiLists.getContactdbListsListIdRecipients

    This endpoint allows you to retrieve all recipients on the list with the given ID.

  • contactsApiLists.patchContactdbListsListId

    This endpoint allows you to update the name of one of your recipient lists.

  • contactsApiLists.postContactdbLists

    This endpoint allows you to create a list for your recipients.

  • contactsApiLists.postContactdbListsListIdRecipients

    This endpoint allows you to add multiple recipients to a list.

    Adds existing recipients to a list, passing in the recipient IDs to add. Recipient IDs should be passed exactly as they are returned from recipient endpoints.

  • contactsApiLists.postContactdbListsListIdRecipientsRecipientId

    This endpoint allows you to add a single recipient to a list.

  • contactsApiRecipients.deleteContactdbRecipients

    This endpoint allows you to deletes one or more recipients.

    The body of an API call to this endpoint must include an array of recipient IDs of the recipients you want to delete.

  • contactsApiRecipients.deleteContactdbRecipientsRecipientId

    This endpoint allows you to delete a single recipient with the given ID from your contact database.

    Use this to permanently delete your recipients from all of your contact lists and all segments if required by applicable law.

  • contactsApiRecipients.getContactdbRecipients

    This endpoint allows you to retrieve all of your Marketing Campaigns recipients.

    Batch deletion of a page makes it possible to receive an empty page of recipients before reaching the end of the list of recipients. To avoid this issue; iterate over pages until a 404 is retrieved.

  • contactsApiRecipients.getContactdbRecipientsBillableCount

    This endpoint allows you to retrieve the number of Marketing Campaigns recipients that you will be billed for.

    You are billed for marketing campaigns based on the highest number of recipients you have had in your account at one time. This endpoint will allow you to know the current billable count value.

  • contactsApiRecipients.getContactdbRecipientsCount

    This endpoint allows you to retrieve the total number of Marketing Campaigns recipients.

  • contactsApiRecipients.getContactdbRecipientsRecipientId

    This endpoint allows you to retrieve a single recipient by ID from your contact database.

  • contactsApiRecipients.getContactdbRecipientsRecipientIdLists

    This endpoint allows you to retrieve the lists that a given recipient belongs to.

    Each recipient can be on many lists. This endpoint gives you all of the lists that any one recipient has been added to.

  • contactsApiRecipients.getContactdbRecipientsSearch

    This endpoint allows you to perform a search on all of your Marketing Campaigns recipients.

    field_name:

    • is a variable that is substituted for your actual custom field name from your recipient.
    • Text fields must be url-encoded. Date fields are searchable only by unix timestamp (e.g. 2/2/2015 becomes 1422835200)
    • If field_name is a 'reserved' date field, such as created_at or updated_at, the system will internally convert your epoch time to a date range encompassing the entire day. For example, an epoch time of 1422835600 converts to Mon, 02 Feb 2015 00:06:40 GMT, but internally the system will search from Mon, 02 Feb 2015 00:00:00 GMT through Mon, 02 Feb 2015 23:59:59 GMT.
  • contactsApiRecipients.getContactdbStatus

    This endpoint allows you to check the upload status of a Marketing Campaigns recipient.

  • contactsApiRecipients.patchContactdbRecipients

    This endpoint allows you to update one or more recipients.

    The body of an API call to this endpoint must include an array of one or more recipient objects.

    It is of note that you can add custom field data as parameters on recipient objects. We have provided an example using some of the default custom fields SendGrid provides.

  • contactsApiRecipients.postContactdbRecipients

    This endpoint allows you to add a Marketing Campaigns recipient.

    You can add custom field data as a parameter on this endpoint. We have provided an example using some of the default custom fields SendGrid provides.

    The rate limit is three requests every 2 seconds. You can upload 1000 contacts per request. So the maximum upload rate is 1500 recipients per second.

  • contactsApiRecipients.postContactdbRecipientsSearch

    Search using segment conditions without actually creating a segment. Body contains a JSON object with conditions, a list of conditions as described below, and an optional list_id, which is a valid list ID for a list to limit the search on.

    Valid operators for create and update depend on the type of the field for which you are searching.

    • Dates:
      • "eq", "ne", "lt" (before), "gt" (after)
        • You may use MM/DD/YYYY for day granularity or an epoch for second granularity.
      • "empty", "not_empty"
      • "is within"
        • You may use an or the # of days.
    • Text: "contains", "eq" (is - matches the full field), "ne" (is not - matches any field where the entire field is not the condition value), "empty", "not_empty"
    • Numbers: "eq", "lt", "gt", "empty", "not_empty"
    • Email Clicks and Opens: "eq" (opened), "ne" (not opened)

    Field values must all be a string.

    Search conditions using "eq" or "ne" for email clicks and opens should provide a "field" of either clicks.campaign_identifier or opens.campaign_identifier. The condition value should be a string containing the id of a completed campaign.

    Search conditions list may contain multiple conditions, joined by an "and" or "or" in the "and_or" field. The first condition in the conditions list must have an empty "and_or", and subsequent conditions must all specify an "and_or".

  • contactsApiSegments.deleteContactdbSegmentsSegmentId

    This endpoint allows you to delete a segment from your recipients database.

    You also have the option to delete all the contacts from your Marketing Campaigns recipient database who were in this segment.

  • contactsApiSegments.getContactdbSegments

    This endpoint allows you to retrieve all of your segments.

  • contactsApiSegments.getContactdbSegmentsSegmentId

    This endpoint allows you to retrieve a single segment with the given ID.

  • contactsApiSegments.getContactdbSegmentsSegmentIdRecipients

    This endpoint allows you to retrieve all of the recipients in a segment with the given ID.

  • contactsApiSegments.patchContactdbSegmentsSegmentId

    This endpoint allows you to update a segment.

  • contactsApiSegments.postContactdbSegments

    This endpoint allows you to create a new segment.

    Valid operators for create and update depend on the type of the field for which you are searching.

    Dates

    • "eq", "ne", "lt" (before), "gt" (after)
      • You may use MM/DD/YYYY for day granularity or an epoch for second granularity.
    • "empty", "not_empty"
    • "is within"
      • You may use an or the # of days.

    Text

    • "contains"
    • "eq" (is/equals - matches the full field)
    • "ne" (is not/not equals - matches any field where the entire field is not the condition value)
    • "empty"
    • "not_empty"

    Numbers

    • "eq" (is/equals)
    • "lt" (is less than)
    • "gt" (is greater than)
    • "empty"
    • "not_empty"

    Email Clicks and Opens

    • "eq" (opened)
    • "ne" (not opened)

    All field values must be a string.

    Conditions using "eq" or "ne" for email clicks and opens should provide a "field" of either clicks.campaign_identifier or opens.campaign_identifier. The condition value should be a string containing the id of a completed campaign.

    The conditions list may contain multiple conditions, joined by an "and" or "or" in the "and_or" field.

    The first condition in the conditions list must have an empty "and_or", and subsequent conditions must all specify an "and_or".

  • csvUiOnly.getV3MessagesDownloadDownloadUuid

    This endpoint will return a presigned URL that can be used to download the CSV that was requested from the "Request a CSV" endpoint.

  • csvUiOnly.postV3MessagesDownload

    This is BETA functionality. You may not have access, and we reserve the right to change functionality without notice.

    This request will kick off a backend process to generate a CSV file. Once generated, the worker will then send an email for the user download the file. The link will expire in 3 days.

    The CSV fill contain the last 1 million messages. This endpoint will be rate limited to 1 request every 12 hours (rate limit may change).

    This endpoint is similar to the GET Single Message endpoint - the only difference is that /download is added to indicate that this is a CSV download requests but the same query is used to determine what the CSV should contain.

  • customFields.deleteMcFieldDefinitionsCustomFieldId

    This endpoint deletes a defined Custom Field.

    You cand delete only Custom Fields; Reserved Fields cannot be deleted.

  • customFields.getMcFieldDefinitions

    This endpoint retrieves all defined Custom Fields and Reserved Fields.

  • customFields.patchMcFieldDefinitionsCustomFieldId

    This endopoint allows you to update a defined Custom Field.

    Only your Custom fields can be modified; Reserved Fields cannot be updated.

  • customFields.postMcFieldDefinitions

    This endpoint creates a new custom field definition.

    Custom field definitions are created with the given name and field_type. Although field names are stored in a case-sensitive manner, all field names must be case-insensitively unique. This means you may create a field named CamelCase or camelcase, but not both. Additionally, a Custom Field name cannot collide with any Reserved Field names. You should save the returned id value in order to update or delete the field at a later date. You can have up to 120 custom fields.

    The custom field name should be created using only alphanumeric characters (A-Z and 0-9) and underscores (_). Custom fields can only begin with letters A-Z or underscores (_). The field type can be date, text, or number fields. The field type is important for creating segments from your contact database.

    Note: Creating a custom field that begins with a number will cause issues with sending in Marketing Campaigns._

  • designsApi.deleteDesign

    This endpoint allows you to delete a single design.

    Be sure to check the ID of the design you intend to delete before making this request; deleting a design is a permanent action.

  • designsApi.getDesign

    This endpoint allows you to retrieve a single design.

    A GET request to /designs/{id} will retrieve details about a specific design in your Design Library.

    This endpoint is valuable when retrieving information stored in a field that you wish to update using a PATCH request.

  • designsApi.getSendgridPreBuiltDesign

    This endpoint allows you to retrieve a single pre-built design.

    A GET request to /designs/pre-builts/{id} will retrieve details about a specific pre-built design.

    This endpoint is valuable when retrieving details about a pre-built design that you wish to duplicate and modify.

  • designsApi.listDesigns

    This endpoint allows you to retrieve a list of designs already stored in your Design Library.

    A GET request to /designs will return a list of your existing designs. This endpoint will not return the pre-built Twilio SendGrid designs. Pre-built designs can be retrieved using the /designs/pre-builts endpoint, which is detailed below.

    By default, you will receive 100 results per request; however, you can modify the number of results returned by passing an integer to the page_size query parameter.

  • designsApi.listSendgridPreBuiltDesigns

    This endpoint allows you to retrieve a list of pre-built designs provided by Twilio SendGrid.

    Unlike the /designs endpoint where your designs are stored, a GET request made to designs/pre-builts will retrieve a list of the pre-built Twilio SendGrid designs. This endpoint will not return the designs stored in your Design Library.

    By default, you will receive 100 results per request; however, you can modify the number of results returned by passing an integer to the page_size query parameter.

    This endpoint is useful for retrieving the IDs of Twilio SendGrid designs that you want to duplicate and modify.

  • designsApi.postDesign

    This endpoint allows you to duplicate one of your existing designs.

    Modifying an existing design is often the easiest way to create something new.

    You are not required to pass any data in the body of a request to this endpoint. If you choose to leave the name field blank, your duplicate will be assigned the name of the design it was copied from with the text "Duplicate: " prepended to it. This name change is only a convenience, as the duplicate will be assigned a unique ID that differentiates it from your other designs.

    You can modify your duplicate’s name at the time of creation by passing an updated value to the name field when making the initial request. More on retrieving design IDs can be found below.

  • designsApi.postDesigns

    This endpoint allows you to create a new design.

    You can add a new design by passing data, including a string of HTML email content, to /designs. When creating designs from scratch, be aware of the styling constraints inherent to many email clients. For a list of best practices, see our guide to .

    The Design Library can also convert your design’s HTML elements into drag and drop modules that are editable in the Designs Library user interface. For more, visit the .

    Because the /designs endpoint makes it easy to add designs, you can create a design with your preferred tooling or migrate designs you already own without relying on the Design Library UI.

  • designsApi.postSendgridPreBuiltDesign

    This endpoint allows you to duplicate one of the pre-built Twilio SendGrid designs.

    Like duplicating one of your existing designs, you are not required to pass any data in the body of a request to this endpoint. If you choose to leave the name field blank, your duplicate will be assigned the name of the design it was copied from with the text "Duplicate: " prepended to it. This name change is only a convenience, as the duplicate design will be assigned a unique ID that differentiates it from your other designs. You can retrieve the IDs for Twilio SendGrid pre-built designs using the "List SendGrid Pre-built Designs" endpoint.

    You can modify your duplicate’s name at the time of creation by passing an updated value to the name field when making the initial request. More on retrieving design IDs can be found above.

  • designsApi.putDesign

    This endpoint allows you to edit a design.

    The Design API supports PATCH requests, which allow you to make partial updates to a single design. Passing data to a specific field will update only the data stored in that field; all other fields will be unaltered.

    For example, updating a design's name requires that you make a PATCH request to this endpoint with data specified for the name field only.

    {    "name": "<Updated Name>"}
  • domainAuthentication.deleteWhitelabelDomainsDomainId

    This endpoint allows you to delete an authenticated domain.

  • domainAuthentication.deleteWhitelabelDomainsIdIpsIp

    This endpoint allows you to remove an IP address from that domain's authentication.

  • domainAuthentication.deleteWhitelabelDomainsSubuser

    This endpoint allows you to disassociate a specific authenticated domain from a subuser.

    Authenticated domains can be associated with (i.e. assigned to) subusers from a parent account. This functionality allows subusers to send mail using their parent's domain authentication. To associate an authenticated domain with a subuser, the parent account must first authenticate and validate the domain. The parent may then associate the authenticated domain via the subuser management tools.

  • domainAuthentication.getWhitelabelDomains

    This endpoint allows you to retrieve a list of all domains you have authenticated.

  • domainAuthentication.getWhitelabelDomainsDefault

    This endpoint allows you to retrieve the default authentication for a domain.

    When creating or updating a domain authentication, you can set the domain as a default. The default domain will be used to send all mail. If you have multiple authenticated domains, the authenticated domain matching the domain of the From address will be used, and the default will be overridden.

    This endpoint will return a default domain and its details only if a default is set. You are not required to set a default. If you do not set a default domain, this endpoint will return general information about your domain authentication status.

  • domainAuthentication.getWhitelabelDomainsDomainId

    This endpoint allows you to retrieve a specific authenticated domain.

  • domainAuthentication.getWhitelabelDomainsSubuser

    This endpoint allows you to retrieve all of the authenticated domains that have been assigned to a specific subuser.

    Authenticated domains can be associated with (i.e. assigned to) subusers from a parent account. This functionality allows subusers to send mail using their parent's domain authentication. To associate an authenticated domain with a subuser, the parent account must first authenticate and validate the domain. The parent may then associate the authenticated domain via the subuser management tools.

  • domainAuthentication.patchWhitelabelDomainsDomainId

    This endpoint allows you to update the settings for an authenticated domain.

  • domainAuthentication.postWhitelabelDomains

    This endpoint allows you to authenticate a domain.

    If you are authenticating a domain for a subuser, you have two options:

    1. Use the "username" parameter. This allows you to authenticate a domain on behalf of your subuser. This means the subuser is able to see and modify the authenticated domain.
    2. Use the Association workflow (see Associate Domain section). This allows you to authenticate a domain created by the parent to a subuser. This means the subuser will default to the assigned domain, but will not be able to see or modify that authenticated domain. However, if the subuser authenticates their own domain it will overwrite the assigned domain.
  • domainAuthentication.postWhitelabelDomainsDomainIdSubuser

    This endpoint allows you to associate a specific authenticated domain with a subuser.

    Authenticated domains can be associated with (i.e. assigned to) subusers from a parent account. This functionality allows subusers to send mail using their parent's domain authentication. To associate an authenticated domain with a subuser, the parent account must first authenticate and validate the domain. The parent may then associate the authenticated domain via the subuser management tools.

  • domainAuthentication.postWhitelabelDomainsIdIps

    This endpoint allows you to add an IP address to an authenticated domain.

  • domainAuthentication.postWhitelabelDomainsIdValidate

    This endpoint allows you to validate an authenticated domain. If it fails, it will return an error message describing why the domain could not be validated.

  • emailAddressValidation.postValidationsEmail

    This endpoint allows you to validate an email address.

  • emailCnameRecords.postWhitelabelDnsEmail

    This endpoint is used to share DNS records with a colleagues

    Use this endpoint to send SendGrid-generated DNS record information to a co-worker so they can enter it into your DNS provider to validate your domain and link branding.

    What type of records are sent will depend on whether you have chosen Automated Security or not. When using Automated Security, SendGrid provides you with three CNAME records. If you turn Automated Security off, you are instead given TXT and MX records.

    If you pass a link_id to this endpoint, the generated email will supply the DNS records necessary to complete setup. If you pass a domain_id to this endpoint, the generated email will supply the DNS records needed to complete . Passing both IDs will generate an email with the records needed to complete both setup steps.

    You can retrieve all your domain IDs from the returned id fields for each domain using the "List all authenticated domains" endpoint. You can retrieve all of your link IDs using the "Retrieve all branded links" endpoint.

  • invalidEmailsApi.deleteSuppressionInvalidEmails

    This endpoint allows you to remove email addresses from your invalid email address list.

    There are two options for deleting invalid email addresses:

    1. You can delete all invalid email addresses by setting delete_all to true in the request body.
    2. You can delete some invalid email addresses by specifying certain addresses in an array in the request body.
  • invalidEmailsApi.deleteSuppressionInvalidEmailsEmail

    This endpoint allows you to remove a specific email address from the invalid email address list.

  • invalidEmailsApi.getSuppressionInvalidEmails

    This endpoint allows you to retrieve a list of all invalid email addresses.

  • invalidEmailsApi.getSuppressionInvalidEmailsEmail

    This endpoint allows you to retrieve a specific invalid email addresses.

  • ipAccessManagement.deleteAccessSettingsWhitelist

    This endpoint allows you to remove one or more IP addresses from your list of allowed addresses.

    To remove one or more IP addresses, pass this endpoint an array containing the ID(s) associated with the IP(s) you intend to remove. You can retrieve the IDs associated with your allowed IP addresses using the "Retrieve a list of currently allowed IPs" endpoint.

    It is possible to remove your own IP address, which will block access to your account. You will need to submit a if this happens. For this reason, it is important to double check that you are removing only the IPs you intend to remove when using this endpoint.

  • ipAccessManagement.deleteAccessSettingsWhitelistRuleId

    This endpoint allows you to remove a specific IP address from your list of allowed addresses.

    When removing a specific IP address from your list, you must include the ID in your call. You can retrieve the IDs associated with your allowed IP addresses using the "Retrieve a list of currently allowed IPs" endpoint.

  • ipAccessManagement.getAccessSettingsActivity

    This endpoint allows you to retrieve a list of all of the IP addresses that recently attempted to access your account either through the User Interface or the API.

  • ipAccessManagement.getAccessSettingsWhitelist

    This endpoint allows you to retrieve a list of IP addresses that are currently allowed to access your account.

    Each IP address returned to you will have created_at and updated_at dates. Each IP will also be associated with an id that can be used to remove the address from your allow list.

  • ipAccessManagement.getAccessSettingsWhitelistRuleId

    This endpoint allows you to retreive a specific IP address that has been allowed to access your account.

    You must include the ID for the specific IP address you want to retrieve in your call. You can retrieve the IDs associated with your allowed IP addresses using the "Retrieve a list of currently allowed IPs" endpoint.

  • ipAccessManagement.postAccessSettingsWhitelist

    This endpoint allows you to add one or more allowed IP addresses.

    To allow one or more IP addresses, pass them to this endpoint in an array. Once an IP address is added to your allow list, it will be assigned an id that can be used to remove the address. You can retrieve the ID associated with an IP using the "Retrieve a list of currently allowed IPs" endpoint.

  • ipAddresses.getIps

    This endpoint allows you to retrieve a list of all assigned and unassigned IPs.

    Response includes warm up status, pools, assigned subusers, and reverse DNS info. The start_date field corresponds to when warmup started for that IP.

    A single IP address or a range of IP addresses may be dedicated to an account in order to send email for multiple domains. The reputation of this IP is based on the aggregate performance of all the senders who use it.

  • ipAddresses.getIpsAssigned

    This endpoint allows you to retrieve only assigned IP addresses.

    A single IP address or a range of IP addresses may be dedicated to an account in order to send email for multiple domains. The reputation of this IP is based on the aggregate performance of all the senders who use it.

  • ipAddresses.getIpsIpAddress

    This endpoint allows you to see which IP pools a particular IP address has been added to.

    The same IP address can be added to multiple IP pools.

    A single IP address or a range of IP addresses may be dedicated to an account in order to send email for multiple domains. The reputation of this IP is based on the aggregate performance of all the senders who use it.

  • ipAddresses.getIpsRemaining

    This endpoint gets amount of IP Addresses that can still be created during a given period and the price of those IPs.

  • ipAddresses.postIps

    This endpoint is for adding a(n) IP Address(es) to your account.

  • ipPools.deleteIpsPoolsPoolName

    This endpoint allows you to delete an IP pool.

  • ipPools.deleteIpsPoolsPoolNameIpsIp

    This endpoint allows you to remove an IP address from an IP pool.

  • ipPools.getIpsPools

    This endpoint allows you to get all of your IP pools.

  • ipPools.getIpsPoolsPoolName

    This endpoint allows you to get all of the IP addresses that are in a specific IP pool.

  • ipPools.postIpsPools

    This endpoint allows you to create an IP pool.

    Before you can create an IP pool, you need to activate the IP in your SendGrid account:

    1. Log into your SendGrid account.
    2. Navigate to Settings and then select IP Addresses.
    3. Find the IP address you want to activate and then click Edit.
    4. Check Allow my account to send mail using this IP address.
    5. Click Save.
  • ipPools.postIpsPoolsPoolNameIps

    This endpoint allows you to add an IP address to an IP pool.

    You can add the same IP address to multiple pools. It may take up to 60 seconds for your IP address to be added to a pool after your request is made.

    Before you can add an IP to a pool, you need to activate it in your SendGrid account:

    1. Log into your SendGrid account.
    2. Navigate to Settings and then select IP Addresses.
    3. Find the IP address you want to activate and then click Edit.
    4. Check Allow my account to send mail using this IP address.
    5. Click Save.

    You can retrieve all of your available IP addresses from the "Retrieve all IP addresses" endpoint.

  • ipPools.putIpsPoolsPoolName

    This endpoint allows you to update the name of an IP pool.

  • ipWarmup.deleteIpsWarmupIpAddress

    This endpoint allows you to remove an IP address from warmup mode.

    Your request will return a 204 status code if the specified IP was successfully removed from warmup mode. To retrieve details of the IP’s warmup status before removing it from warmup mode, call the "Retrieve the warmpup status for a specific IP address" endpoint.

  • ipWarmup.getIpsWarmup

    This endpoint allows you to retrieve all of your IP addresses that are currently warming up.

  • ipWarmup.getIpsWarmupIpAddress

    This endpoint allows you to retrieve the warmup status for a specific IP address.

    You can retrieve all of your warming IPs using the "Retrieve all IPs currently in warmup" endpoint.

  • ipWarmup.postIpsWarmup

    This endpoint allows you to put an IP address into warmup mode.

  • linkBranding.deleteWhitelabelLinksId

    This endpoint allows you to delete a branded link.

    Your request will receive a response with a 204 status code if the deletion was successful. The call does not return the link's details, so if you wish to record these make sure you call the "Retrieve a branded link" endpoint before you request its deletion.

    You can submit this request as one of your subusers if you include their ID in the on-behalf-of header in the request.

  • linkBranding.deleteWhitelabelLinksSubuser

    This endpoint allows you to take a branded link away from a subuser.

    Link branding can be associated with subusers from the parent account. This functionality allows subusers to send mail using their parent's link branding. To associate link branding, the parent account must first create a branded link and validate it. The parent may then associate that branded link with a subuser via the API or the .

    Your request will receive a response with a 204 status code if the disassociation was successful.

  • linkBranding.getWhitelabelLinks

    This endpoint allows you to retrieve all branded links.

    You can submit this request as one of your subusers if you include their ID in the on-behalf-of header in the request.

  • linkBranding.getWhitelabelLinksDefault

    This endpoint allows you to retrieve the default branded link.

    The default branded link is the actual URL to be used when sending messages. If you have more than one branded link, the default is determined by the following order:

    • The validated branded link marked as default (set when you call the "Create a branded link" endpoint or by calling the "Update a branded link" endpoint on an existing link)
    • Legacy branded links (migrated from the whitelabel wizard)
    • Default SendGrid-branded links (i.e., 100.ct.sendgrid.net)

    You can submit this request as one of your subusers if you include their ID in the on-behalf-of header in the request.

  • linkBranding.getWhitelabelLinksId

    This endpoint allows you to retrieve a specific branded link by providing its ID.

    You can submit this request as one of your subusers if you include their ID in the on-behalf-of header in the request.

  • linkBranding.getWhitelabelLinksSubuser

    This endpoint allows you to retrieve the branded link associated with a subuser.

    Link branding can be associated with subusers from the parent account. This functionality allows subusers to send mail using their parent's link branding. To associate link branding, the parent account must first create a branded link and then validate it. The parent may then associate that branded link with a subuser via the API or the .

  • linkBranding.patchWhitelabelLinksId

    This endpoint allows you to update a specific branded link. You can use this endpoint to change a branded link's default status.

    You can submit this request as one of your subusers if you include their ID in the on-behalf-of header in the request.

  • linkBranding.postWhitelabelLinks

    This endpoint allows you to create a new branded link.

    To create the link branding, supply the root domain and, optionally, the subdomain — these go into separate fields in your request body. The root domain should match your FROM email address. If you provide a subdomain, it must be different from the subdomain you used for authenticating your domain.

    You can submit this request as one of your subusers if you include their ID in the on-behalf-of header in the request.

  • linkBranding.postWhitelabelLinksIdValidate

    This endpoint allows you to validate a branded link.

    You can submit this request as one of your subusers if you include their ID in the on-behalf-of header in the request.

  • linkBranding.postWhitelabelLinksLinkIdSubuser

    This endpoint allows you to associate a branded link with a subuser account.

    Link branding can be associated with subusers from the parent account. This functionality allows subusers to send mail using their parent's link branding. To associate link branding, the parent account must first create a branded link and validate it. The parent may then associate that branded link with a subuser via the API or the .

  • lists.deleteListsId

    This endpoint allows you to deletes a specific list.

    Optionally, you can also delete contacts associated to the list. The query parameter, delete_contacts=true, will delete the list and start an asynchronous job to delete associated contacts.

  • lists.deleteMcListsIdContacts

    This endpoint allows you to remove contacts from a given list.

    The contacts will not be deleted. Only their list membership will be changed.

  • lists.getMcLists

    This endpoint returns an array of all of your contact lists.

  • lists.getMcListsId

    This endpoint returns data about a specific list.

    Setting the optional parameter contact_sample=true returns the contact_sample in the response body. Up to fifty of the most recent contacts uploaded or attached to a list will be returned, sorted alphabetically, by email address.

    The full contact count is also returned.

  • lists.getMcListsIdContactsCount

    This endpoint returns the number of contacts on a specific list.

  • lists.patchMcListsId

    This endpoint updates the name of a list.

  • lists.postMcLists

    This endpoint creates a new contacts list.

    Once you create a list, you can use the UI to every time you add a new contact to the list.

    A link to the newly created object is in _metadata.

  • mailSend.postMailSend

    The Mail Send endpoint allows you to send email over SendGrid’s v3 Web API, the most recent version of our API. If you are looking for documentation about the v2 Mail Send endpoint, see our .

    Helper Libraries

    Twilio SendGrid provides libraries to help you quickly and easily integrate with the v3 Web API in 7 different languages:

    Dynamic Transactional Templates and Handlebars

    In order to send a dynamic template, specify the template ID with the template_id parameter.

    To specify handlebar substitutions, define your substitutions in the request JSON with this syntax:

    "dynamic_template_data": {      "guest": "Jane Doe",      "partysize": "4",      "english": true,      "date": "April 1st, 2021"    }

    For more information about Dynamic Transactional Templates and Handlebars, see our documentation and reference pages.

    Mail Body Compression

    Mail body compression is available to some high volume accounts. Talk to your CSM if you are interested in this functionality. Mail body compression works by setting up a JSON payload as defined on this page, then compressing it with gzip (the gzip file can be no more than 30mb).

    To use mail body compression:

    1. Add a Content-Encoding header, with a value of gzip.
      a. Content-Encoding: gzip
    2. Send the gzip as a data-binary.
      a. --data-binary '@data.json.gz'

    Multiple Reply-To Emails

    Using reply_to_list allows senders to include more than one recipient email address to receive reply and/or bounce messages from the recipient of the email.

    Usage Considerations

    • reply_to is mutually exclusive with reply_to_list. If both are used, then the API call will be rejected.
    • The reply_to_list object, when used, must at least have an email parameter and may also contain a name parameter.
    • Each email address in the reply_to_list should be unique.
    • There is a limit of 1000 reply_to_list emails per mail/send request.
    • In SMTP calls, we will omit any invalid emails.

    Possible 400 Error Messages

    • reply_to is mutually exclusive with reply_to_list.
    • The reply_to_list object, when used, must at least have an email parameter and may also contain a name parameter.
    • Each email address in the reply_to_list should be unique.
    • There is a limit of X reply_to emails per mail/send request.
    • The reply_to_list email does not contain a valid address.
    • The reply_to_list email exceeds the maximum total length of X characters.
    • The reply_to_list email parameter is required.
  • marketingCampaignsStats.getallAutomationStats

    This endpoint allows you to retrieve stats for all your Automations.

    By default, all of your Automations will be returned, but you can specify a selection by passing in a comma-separated list of Automation IDs as the value of the query string parameter automation_ids.

    Responses are paginated. You can limit the number of responses returned per batch using the page_size query string parameter. The default is 50, but you specify a value between 1 and 100.

    You can retrieve a specific page of responses with the page_token query string parameter.

  • marketingCampaignsStats.getallSinglesendStats

    This endpoint allows you to retrieve stats for all your Single Sends.

    By default, all of your Single Sends will be returned, but you can specify a selection by passing in a comma-separated list of Single Send IDs as the value of the query string parameter singlesend_ids.

    Responses are paginated. You can limit the number of responses returned per batch using the page_size query string parameter. The default is 50, but you specify a value between 1 and 100.

    You can retrieve a specific page of responses with the page_token query string parameter.

  • marketingCampaignsStats.getAutomationLinkStat

    This endpoint lets you retrieve click-tracking stats for a single Automation.

    The stats returned list the URLs embedded in your Automation and the number of clicks each one received.

    Responses are paginated. You can limit the number of responses returned per batch using the page_size query string parameter. The default is 50, but you specify a value between 1 and 100.

    You can retrieve a specific page of responses with the page_token query string parameter.

  • marketingCampaignsStats.getAutomationsStatsExport

    This endpoint allows you to export Automation stats as CSV data.

    You can specify one Automation or many: include as many Automation IDs as you need, separating them with commas, as the value of the ids query string paramter.

    The data is returned as plain text response but in CSV format, so your application making the call can present the information in whatever way is most appropriate, or just save the data as a .csv file.

  • marketingCampaignsStats.getAutomationStat

    This endpoint allows you to retrieve stats for a single Automation using its ID.

    Multiple Automation IDs can be retrieved using the "Get All Automation Stats" endpoint. Once you have an ID, this endpoint will return detailed stats for the single automation specified.

    You may constrain the stats returned using the start_date and end_date query string parameters. You can also use the group_by and aggregated_by query string parameters to further refine the stats returned.

  • marketingCampaignsStats.getSinglesendLinkStat

    This endpoint lets you retrieve click-tracking stats for one Single Send.

    The stats returned list the URLs embedded in the specified Single Send and the number of clicks each one received.

    Responses are paginated. You can limit the number of responses returned per batch using the page_size query string parameter. The default is 50, but you specify a value between 1 and 100.

    You can retrieve a specific page of responses with the page_token query string parameter.

  • marketingCampaignsStats.getSinglesendStat

    This endpoint allows you to retrieve stats for an individual Single Send using a Single Send ID.

    Multiple Single Send IDs can be retrieved using the "Get All Single Sends Stats" endpoint. Once you have an ID, this endpoint will return detailed stats for the Single Send specified.

    You may constrain the stats returned using the start_date and end_date query string parameters. You can also use the group_by and aggregated_by query string parameters to further refine the stats returned.

  • marketingCampaignsStats.getSinglesendStatsExport

    This endpoint allows you to export Single Send stats as .CSV data.

    You can specify one Single Send or many: include as many Single Send IDs as you need, separating them with commas, as the value of the ids query string paramter.

    The data is returned as plain text response but in .CSV format, so your application making the call can present the information in whatever way is most appropriate, or just save the data as a .csv file.

  • query.getMessages

    This is BETA functionality. You may not have access, and we reserve the right to change functionality without notice.

    Filter all messages to search your Email Activity. All queries need to be , and have this format:

    query={query_type}="{query_content}"

    encoded, this would look like this:

    query=type%3D%22query_content%22

    for example:

    Filter by a specific email - query=to_email%3D%22example%40example.com%22

    Filter by subject line - query=subject%3d%22A%20Great%20Subject%22

    Full list of basic query types and examples:

    Filter queryUnencoded Example (put this one into the try it out query - it'll automatically encode it for you)Encoded Example (use this one in your code)
    msg_idmsg_id=“filter0307p1las1-16816-5A023E36-1.0”msg_id%3D%22filter0307p1las1-16816-5A023E36-1.0%22
    from_emailfrom_email=“from_email%3D%22testing%40sendgrid.net%22
    subjectsubject="This is a subject test"subject%22This%20is%20a%20subject%20test%22
    to_emailto_email=""to_email%3D%22example%40example.com%22
    statusstatus%22processed%22
    template_id
    asm_group_id
    api_key_id
    eventsstatus="processed"status%3D%22processed%22
    originating_ip
    categories
    unique_args
    outbound_ip
    last_event_timelast_event_time=“2017-11-07T23:13:58Z”last_event_time%3D%E2%80%9C2017-11-07T23%3A13%3A58Z%E2%80%9D
    clicksclicks="0"clicks%3D%220%22

    For information about building compound queries, and for the full query language functionality, see the .

    Coming soon, example compound queries: limit + to email + date

  • query.getV3MessagesMsgId

    This is BETA functionality. You may not have access, and we reserve the right to change functionality without notice.

    Get all of the details about the specified message.

  • reverseDns.deleteWhitelabelIpsId

    This endpoint allows you to delete a reverse DNS record.

    A call to this endpoint will respond with a 204 status code if the deletion was successful.

    You can retrieve the IDs associated with all your reverse DNS records using the "Retrieve all reverse DNS records" endpoint.

  • reverseDns.getWhitelabelIps

    This endpoint allows you to retrieve all of the Reverse DNS records created by this account.

    You may include a search key by using the ip query string parameter. This enables you to perform a prefix search for a given IP segment (e.g., ?ip="192.").

    Use the limit query string parameter to reduce the number of records returned. All records will be returned if you have fewer records than the specified limit.

    The offset query string parameter allows you to specify a non-zero index from which records will be returned. For example, if you have ten records, ?offset=5 will return the last five records (at indexes 5 through 9). The list starts at index zero.

  • reverseDns.getWhitelabelIpsId

    This endpoint allows you to retrieve a reverse DNS record.

    You can retrieve the IDs associated with all your reverse DNS records using the "Retrieve all reverse DNS records" endpoint.

  • reverseDns.postWhitelabelIps

    This endpoint allows you to set up reverse DNS.

  • reverseDns.postWhitelabelIpsIdValidate

    This endpoint allows you to validate a reverse DNS record.

    Always check the valid property of the response’s validation_results.a_record object. This field will indicate whether it was possible to validate the reverse DNS record. If the validation_results.a_record.valid is false, this indicates only that Twilio SendGrid could not determine the validity your reverse DNS record — it may still be valid.

    If validity couldn’t be determined, you can check the value of validation_results.a_record.reason to find out why.

    You can retrieve the IDs associated with all your reverse DNS records using the "Retrieve all reverse DNS records" endpoint.

  • segmentingContacts.deleteMarketingSegmentsSegmentId

    This endpoint allows you to delete a segment by segment_id.

    Note that deleting a segment does not delete the contacts associated with the segment by default. Contacts associated with a deleted segment will remain in your list of all contacts and any other segments they belong to.

  • segmentingContacts.getMarketingSegments

    This endpoint allows you to retrieve a list of segments.

    The query param parent_list_ids is treated as a filter. Any match will be returned. 0 matches will return a response code of 200 with an empty results array.

    parent_list_idsno_parent_list_idresult
    emptyfalseall segments
    valuesfalsesegments filtered by list_ids
    valuestruesegments filtered by list_ids and segments with no parent list_ids
    emptytruesegments with no parent list_ids
  • segmentingContacts.getMarketingSegmentsSegmentId

    This endpoint allows you to retrieve a single segment by ID.

  • segmentingContacts.patchMarketingSegmentsSegmentId

    This endpoint allows you to update a segment.

    Segment name needs to be unique. A user can not update a segment name to an existing one.

  • segmentingContacts.postMarketingSegments

    This endpoint allows you to create a segment.

  • segmentingContacts.postMarketingSegmentsDelete

    This endpoint allows you to delete segments in bulk.

    If the segments are used by automations or the segments do not exist in the database, the segment IDs that could not be deleted along with automation IDs that are associated to those segments will be returned.

  • segmentingContactsV2Beta.deleteSegmentsSegmentId

    The Segmentation V2 API is currently in private beta. If you'd like to be added to the beta, please fill out this form [blocked]

  • segmentingContactsV2Beta.getSegments

    The Segmentation V2 API is currently in private beta. If you'd like to be added to the beta, please fill out this form [blocked]

    The query param parent_list_ids is treated as a filter. Any match will be returned. 0 matches will return a response code of 200 with an empty results array.

    parent_list_idsno_parent_list_idresult
    emptyfalseall segments
    valuesfalsesegments filtered by list_ids
    valuestruesegments filtered by list_ids and segments with no parent list_ids
    emptytruesegments with no parent list_ids
  • segmentingContactsV2Beta.getSegmentsSegmentId

    The Segmentation V2 API is currently in private beta. If you'd like to be added to the beta, please fill out this form [blocked]

  • segmentingContactsV2Beta.patchSegmentsSegmentId

    The Segmentation V2 API is currently in private beta. If you'd like to be added to the beta, please fill out this form [blocked]

    Segment name has to be unique. A user can not create a new segment with an existing segment name.

  • segmentingContactsV2Beta.postSegments

    The Segmentation V2 API is currently in private beta. If you'd like to be added to the beta, please fill out this form [blocked]

    Segment name has to be unique. A user can not create a new segment with an existing segment name.

  • senderIdentitiesApi.deleteV3SendersSenderId

    This endoint allows you to delete one of your sender identities.

  • senderIdentitiesApi.getV3Senders

    This endpoint allows you to retrieve a list of all sender identities that have been created for your account.

  • senderIdentitiesApi.getV3SendersSenderId

    This endpoint allows you to retrieve a specific sender identity.

  • senderIdentitiesApi.patchV3SendersSenderId

    This endpoint allows you to update a sender identity.

    Updates to from.email require re-verification.

    Partial updates are allowed, but fields that are marked as "required" in the POST (create) endpoint must not be nil if that field is included in the PATCH request.

  • senderIdentitiesApi.postSenders

    This endpoint allows you to create a new sender identity.

    You may create up to 100 unique sender identities.

  • senderIdentitiesApi.postV3SendersSenderIdResendVerification

    This enpdoint allows you to resend a sender identity verification email.

  • senders.postMarketingSenders

    This endpoint allows you to create a new sender identity.

    You may create up to 100 unique sender identities.

    Sender identities are required to be verified before use. If your domain has been authenticated, a new sender identity will auto verify on creation. Otherwise an email will be sent to the from.email.

  • senderVerification.deleteVerifiedSendersId

    This endpoint allows you to delete a Sender Identity.

    Pass the id assigned to a Sender Identity to this endpoint to delete the Sender Identity from your account.

    You can retrieve the IDs associated with Sender Identities using the "Get All Verified Senders" endpoint.

  • senderVerification.getVerifiedSenders

    This endpoint allows you to retrieve all the Sender Identities associated with an account.

    This endpoint will return both verified and unverified senders.

    You can limit the number of results returned using the limit, lastSeenID, and id query string parameters.

    • limit allows you to specify an exact number of Sender Identities to return.
    • lastSeenID will return senders with an ID number occuring after the passed in ID. In other words, the lastSeenID provides a starting point from which SendGrid will iterate to find Sender Identities associated with your account.
    • id will return information about only the Sender Identity passed in the request.
  • senderVerification.getVerifiedSendersDomains

    This endpoint returns a list of domains known to implement DMARC and categorizes them by failure type — hard failure or soft failure.

    Domains listed as hard failures will not deliver mail when used as a due to the domain's DMARC policy settings.

    For example, using a yahoo.com email address as a Sender Identity will likely result in the rejection of your mail. For more information about DMARC, see .

  • senderVerification.getVerifiedSendersStepsCompleted

    This endpoint allows you to determine which of SendGrid’s verification processes have been completed for an account.

    This endpoint returns boolean values, true and false, for , domain_verified, and , sender_verified, for the account.

    An account may have one, both, or neither verification steps completed. If you need to authenticate a domain rather than a Single Sender, see the "Authenticate a domain" endpoint.

  • senderVerification.getVerifiedSendersVerifyToken

    This endpoint allows you to verify a sender requests.

    The token is generated by SendGrid and included in a verification email delivered to the address that's pending verification.

  • senderVerification.patchVerifiedSendersId

    This endpoint allows you to update an existing Sender Identity.

    Pass the id assigned to a Sender Identity to this endpoint as a path parameter. Include any fields you wish to update in the request body in JSON format.

    You can retrieve the IDs associated with Sender Identities by passing a GET request to the Get All Verified Senders endpoint, /verified_senders.

    Note: Unlike a PUT request, PATCH allows you to update only the fields you wish to edit. Fields that are not passed as part of a request will remain unaltered.

  • senderVerification.postVerifiedSenders

    This endpoint allows you to create a new Sender Identify.

    Upon successful submission of a POST request to this endpoint, an identity will be created, and a verification email will be sent to the address assigned to the from_email field. You must complete the verification process using the sent email to fully verify the sender.

    If you need to resend the verification email, you can do so with the Resend Verified Sender Request, /resend/{id}, endpoint.

    If you need to authenticate a domain rather than a Single Sender, see the .

  • senderVerification.postVerifiedSendersResendId

    This endpoint allows you to resend a verification email to a specified Sender Identity.

    Passing the id assigned to a Sender Identity to this endpoint will resend a verification email to the from_address associated with the Sender Identity. This can be useful if someone loses their verification email or needs to have it resent for any other reason.

    You can retrieve the IDs associated with Sender Identities by passing a "Get All Verified Senders" endpoint.

  • sendTestEmail.postMarketingTestSendEmail

    This endpoint allows you to send a test marketing email to a list of email addresses.

    Before sending a marketing message, you can test it using this endpoint. You may specify up to 10 contacts in the emails request body field. You must also specify a template_id and include either a from_address or sender_id. You can manage your templates with the or the .

    Please note that this endpoint works with Dynamic Transactional Templates only. Legacy Transactional Templates will not be delivered.

    For more information about managing Dynamic Transactional Templates, see .

    You can also test your Single Sends in the .

  • settingsEnforcedTls.getUserSettingsEnforcedTls

    This endpoint allows you to retrieve your current Enforced TLS settings.

    The Enforced TLS settings specify whether or not the recipient is required to support TLS or have a valid certificate.

    If either require_tls or require_valid_cert is set to true, the recipient must support TLS 1.1 or higher or have a valid certificate. If these conditions are not met, Twilio SendGrid will drop the message and send a block event with “TLS required but not supported” as the description.

  • settingsEnforcedTls.patchUserSettingsEnforcedTls

    This endpoint allows you to update your Enforced TLS settings.

    To require TLS from recipients, set require_tls to true. If either require_tls or require_valid_cert is set to true, the recipient must support TLS 1.1 or higher or have a valid certificate. If these conditions are not met, Twilio SendGrid will drop the message and send a block event with “TLS required but not supported” as the description.

    Twilio SendGrid supports TLS 1.1 and higher and does not support older versions of TLS due to security vulnerabilities.

  • settingsInboundParse.deleteUserWebhooksParseSettingsHostname

    This endpoint allows you to delete a specific inbound parse setting by hostname.

    You can retrieve all your Inbound Parse settings and their associated host names with the "Retrieve all parse settings" endpoint.

  • settingsInboundParse.getUserWebhooksParseSettingsHostname

    This endpoint allows you to retrieve a specific inbound parse setting by hostname.

    You can retrieve all your Inbound Parse settings and their associated host names with the "Retrieve all parse settings" endpoint.

  • settingsInboundParse.patchUserWebhooksParseSettingsHostname

    This endpoint allows you to update a specific inbound parse setting by hostname.

    You can retrieve all your Inbound Parse settings and their associated host names with the "Retrieve all parse settings" endpoint.

  • settingsInboundParse.postUserWebhooksParseSettings

    This endpoint allows you to create a new inbound parse setting.

    Creating an Inbound Parse setting requires two pieces of information: a url and a hostname.

    The hostname must correspond to a domain authenticated by Twilio SendGrid on your account. If you need to complete domain authentication, you can use the or the "Authenticate a domain" endpoint. See "" for instructions.

    Any email received by the hostname will be parsed when you complete this setup. You must also add a Twilio SendGrid MX record to this domain's DNS records. See "" for full instructions.

    The url represents a location where the parsed message data will be delivered. Twilio SendGrid will make an HTTP POST request to this url with the message data. The url must be publicly reachable, and your application must return a 200 status code to signal that the message data has been received.

  • settingsMail.getMailSettings

    This endpoint allows you to retrieve a list of all mail settings.

    Each setting will be returned with an enabled status set to true or false and a short description that explains what the setting does.

  • settingsMail.getMailSettingsAddressWhitelist

    This endpoint allows you to retrieve your current email address whitelist settings.

    The Address Whitelist setting allows you to specify email addresses or domains for which mail should never be suppressed.

    For example, if you own the domain example.com, and one or more of your recipients use email@example.com addresses, placing example.com in the address whitelist setting instructs Twilio SendGrid to ignore all bounces, blocks, and unsubscribes logged for that domain. In other words, all bounces, blocks, and unsubscribes will still be sent to example.com as if they were sent under normal sending conditions.

  • settingsMail.getMailSettingsBouncePurge

    This endpoint allows you to retrieve your current bounce and purge settings.

    The Bounce Perge setting allows you to set a schedule that Twilio SendGrid will use to automatically delete contacts from your soft and hard bounce suppression lists.

    A hard bounce occurs when an email message has been returned to the sender because the recipient's address is invalid. A hard bounce might occur because the domain name doesn't exist or because the recipient is unknown.

    A soft bounce occurs when an email message reaches the recipient's mail server but is bounced back undelivered before it actually reaches the recipient. A soft bounce might occur because the recipient's inbox is full.

    You can also manage this setting in the . You can manage your bounces manually using the or the .

  • settingsMail.getMailSettingsFooter

    This endpoint allows you to retrieve your current Footer mail settings.

    The Footer setting will insert a custom footer at the bottom of your text and HTML email message bodies.

    You can insert your HTML or plain text directly using the "Update footer mail settings" endpoint, or you can create the footer using the .

  • settingsMail.getMailSettingsForwardBounce

    This endpoint allows you to retrieve your current bounce forwarding mail settings.

    Enabling the Forward Bounce setting allows you to specify email addresses to which bounce reports will be forwarded. This endpoint returns the email address you have set to receive forwarded bounces and an enabled status indicating if the setting is active.

  • settingsMail.getMailSettingsForwardSpam

    This endpoint allows you to retrieve your current Forward Spam mail settings.

    Enabling the Forward Spam setting allows you to specify email addresses to which spam reports will be forwarded. This endpoint returns any email address(es) you have set to receive forwarded spam and an enabled status indicating if the setting is active.

  • settingsMail.getMailSettingsTemplate

    This endpoint allows you to retrieve your current legacy email template settings.

    This setting refers to our original email templates. We currently support more fully featured .

    The legacy email template setting wraps an HTML template around your email content. This can be useful for sending out marketing email and/or other HTML formatted messages. For instructions on using legacy templates, see how to . For help migrating to our current template system, see .

  • settingsMail.patchMailSettingsAddressWhitelist

    This endpoint allows you to update your current email address whitelist settings.

    You can select whether or not this setting should be enabled by assigning the enabled field a true or false value.

    Passing only the enabled field to this endpoint will not alter your current list of whitelist entries. However, any modifications to your list of entries will overwrite the entire list. For this reason, you must included all existing entries you wish to retain in your list in addition to any new entries you intend to add. To remove one or more list entries, pass a list with only the entries you wish to retain.

    You should not add generic domains such as gmail.com or yahoo.com in your list because your emails will not honor recipients' unsubscribes. This may cause a legal violation of and could damage your sending reputation.

    The Address Whitelist setting allows you to specify email addresses or domains for which mail should never be suppressed.

    For example, if you own the domain example.com, and one or more of your recipients use email@example.com addresses, placing example.com in the address whitelist setting instructs Twilio SendGrid to ignore all bounces, blocks, and unsubscribes logged for that domain. In other words, all bounces, blocks, and unsubscribes will still be sent to example.com as if they were sent under normal sending conditions.

  • settingsMail.patchMailSettingsBouncePurge

    This endpoint allows you to update your current bounce and purge settings.

    The Bounce Perge setting allows you to set a schedule that Twilio SendGrid will use to automatically delete contacts from your soft and hard bounce suppression lists. The schedule is set in full days by assigning the number of days, an integer, to the soft_bounces and/or hard_bounces fields.

    A hard bounce occurs when an email message has been returned to the sender because the recipient's address is invalid. A hard bounce might occur because the domain name doesn't exist or because the recipient is unknown.

    A soft bounce occurs when an email message reaches the recipient's mail server but is bounced back undelivered before it actually reaches the recipient. A soft bounce might occur because the recipient's inbox is full.

    You can also manage this setting in the . You can manage your bounces manually using the or the .

  • settingsMail.patchMailSettingsFooter

    This endpoint allows you to update your current Footer mail settings.

    The Footer setting will insert a custom footer at the bottom of your text and HTML email message bodies.

    You can insert your HTML or plain text directly using this endpoint, or you can create the footer using the .

  • settingsMail.patchMailSettingsForwardBounce

    This endpoint allows you to update your current bounce forwarding mail settings.

    Enabling the Forward Bounce setting allows you to specify an email address to which bounce reports will be forwarded.

    You can also configure the Forward Spam mail settings in the .

  • settingsMail.patchMailSettingsForwardSpam

    This endpoint allows you to update your current Forward Spam mail settings.

    Enabling the Forward Spam setting allows you to specify email addresses to which spam reports will be forwarded. You can set multiple addresses by passing this endpoint a comma separated list of emails in a single string.

    {  "email": "address1@example.com, address2@exapmle.com",  "enabled": true}

    The Forward Spam setting may also be used to receive emails sent to abuse@ and postmaster@ role addresses if you have authenticated your domain.

    For example, if you authenticated example.com as your root domain and set a custom return path of sub for that domain, you could turn on Forward Spam, and any emails sent to abuse@sub.example.com or postmaster@sub.example.com would be forwarded to the email address you entered in the email field.

    You can authenticate your domain using the "Authenticate a domain" endpoint or in the . You can also configure the Forward Spam mail settings in the .

  • settingsMail.patchMailSettingsTemplate

    This endpoint allows you to update your current legacy email template settings.

    This setting refers to our original email templates. We currently support more fully featured .

    The legacy email template setting wraps an HTML template around your email content. This can be useful for sending out marketing email and/or other HTML formatted messages. For instructions on using legacy templates, see how to . For help migrating to our current template system, see .

  • settingsPartner.getPartnerSettings

    This endpoint allows you to retrieve a list of all partner settings that you can enable.

    Our partner settings allow you to integrate your SendGrid account with our partners to increase your SendGrid experience and functionality. For more information about our partners, and how you can begin integrating with them, please visit our .

  • settingsPartner.getPartnerSettingsNewRelic

    This endpoint allows you to retrieve your current New Relic partner settings.

    Our partner settings allow you to integrate your SendGrid account with our partners to increase your SendGrid experience and functionality. For more information about our partners, and how you can begin integrating with them, please visit our .

    By integrating with New Relic, you can send your SendGrid email statistics to your New Relic Dashboard. If you enable this setting, your stats will be sent to New Relic every 5 minutes. You will need your New Relic License Key to enable this setting. For more information, please see our .

  • settingsPartner.patchPartnerSettingsNewRelic

    This endpoint allows you to update or change your New Relic partner settings.

    Our partner settings allow you to integrate your SendGrid account with our partners to increase your SendGrid experience and functionality. For more information about our partners, and how you can begin integrating with them, please visit our .

    By integrating with New Relic, you can send your SendGrid email statistics to your New Relic Dashboard. If you enable this setting, your stats will be sent to New Relic every 5 minutes. You will need your New Relic License Key to enable this setting. For more information, please see our .

  • settingsTracking.getTrackingSettings

    This endpoint allows you to retrieve a list of all tracking settings on your account.

  • settingsTracking.getTrackingSettingsClick

    This endpoint allows you to retrieve your current click tracking setting.

    Click Tracking overrides all the links and URLs in your emails and points them to either SendGrid’s servers or the domain with which you branded your link. When a customer clicks a link, SendGrid tracks those .

    Click tracking helps you understand how users are engaging with your communications. SendGrid can track up to 1000 links per email

  • settingsTracking.getTrackingSettingsGoogleAnalytics

    This endpoint allows you to retrieve your current setting for Google Analytics.

    Google Analytics helps you understand how users got to your site and what they're doing there. For more information about using Google Analytics, please refer to and their article on .

    We default the settings to Google’s recommendations. For more information, see .

  • settingsTracking.getTrackingSettingsOpen

    This endpoint allows you to retrieve your current settings for open tracking.

    Open Tracking adds an invisible image at the end of the email which can track email opens.

    If the email recipient has images enabled on their email client, a request to SendGrid’s server for the invisible image is executed and an open event is logged.

    These events are logged in the Statistics portal, Email Activity interface, and are reported by the Event Webhook.

  • settingsTracking.getTrackingSettingsSubscription

    This endpoint allows you to retrieve your current settings for subscription tracking.

    Subscription tracking adds links to the bottom of your emails that allows your recipients to subscribe to, or unsubscribe from, your emails.

  • settingsTracking.patchTrackingSettingsClick

    This endpoint allows you to enable or disable your current click tracking setting.

    Click Tracking overrides all the links and URLs in your emails and points them to either SendGrid’s servers or the domain with which you branded your link. When a customer clicks a link, SendGrid tracks those .

    Click tracking helps you understand how users are engaging with your communications. SendGrid can track up to 1000 links per email

  • settingsTracking.patchTrackingSettingsGoogleAnalytics

    This endpoint allows you to update your current setting for Google Analytics.

    Google Analytics helps you understand how users got to your site and what they're doing there. For more information about using Google Analytics, please refer to and their article on .

    We default the settings to Google’s recommendations. For more information, see .

  • settingsTracking.patchTrackingSettingsOpen

    This endpoint allows you to update your current settings for open tracking.

    Open Tracking adds an invisible image at the end of the email which can track email opens.

    If the email recipient has images enabled on their email client, a request to SendGrid’s server for the invisible image is executed and an open event is logged.

    These events are logged in the Statistics portal, Email Activity interface, and are reported by the Event Webhook.

  • settingsTracking.patchTrackingSettingsSubscription

    This endpoint allows you to update your current settings for subscription tracking.

    Subscription tracking adds links to the bottom of your emails that allows your recipients to subscribe to, or unsubscribe from, your emails.

  • singleSends.deleteMarketingSinglesends

    This endpoint allows you to delete multiple Single Sends using an array of Single Sends IDs.

    To first retrieve all your Single Sends' IDs, you can make a GET request to the /marketing/singlensends endpoint.

    Please note that a DELETE request is permanent, and your Single Sends will not be recoverable after deletion.

  • singleSends.deleteMarketingSinglesendsId

    This endpoint allows you to delete one Single Send using a Single Send ID.

    To first retrieve all your Single Sends' IDs, you can make a GET request to the /marketing/singlensends endpoint.

    Please note that a DELETE request is permanent, and your Single Send will not be recoverable after deletion.

  • singleSends.deleteMarketingSinglesendsIdSchedule

    This endpoint allows you to cancel a scheduled Single Send using a Single Send ID.

    Making a DELETE request to this endpoint will cancel the scheduled sending of a Single Send. The request will not delete the Single Send itself. Deleting a Single Send can be done by passing a DELETE request to /marketing/singlesends/{id}.

  • singleSends.getMarketingSinglesends

    This endpoint allows you to retrieve all your Single Sends.

    Returns all of your Single Sends with condensed details about each, including the Single Sends' IDs. For more details about an individual Single Send, pass the Single Send's ID to the /marketing/singlesends/{id} endpoint.

  • singleSends.getMarketingSinglesendsCategories

    This endpoint allows you to retrieve all the categories associated with your Single Sends.

    This endpoint will return your latest 1,000 categories.

[...]
